#!/bin/bash
PRODUCTNAME="statexplorer"
TMPDIR="/tmp/statexplorer"
INSTALLDIR="/usr/share/ombutel/www"
IPCDIR="/etc/ipconnect"
OLDVERSION=-1
NEWVERSION=-1
MAJORVERSION=3


mkdir -p "$TMPDIR"
mkdir -p "$IPCDIR"

if [ -e "$IPCDIR/$PRODUCTNAME.ver" ]
then
    OLDVERSION=$(cat "$IPCDIR/$PRODUCTNAME.ver" |cut -d"." -f2)
fi
NEWVERSION=$(head -n 1 "$INSTALLDIR/$PRODUCTNAME/version.txt" |cut -d"." -f2)
echo "-- Updating from $MAJORVERSION.$OLDVERSION to $MAJORVERSION.$NEWVERSION"

find "$INSTALLDIR/$PRODUCTNAME/api/scripts" -name '*.sh' -exec dos2unix {} 2> /dev/null \;

if [ ! -f "/etc/$PRODUCTNAME/Settings.php" ]
then
    echo "-- Creating settings"
    cp "$INSTALLDIR/$PRODUCTNAME/api/Settings_template.php" "/etc/$PRODUCTNAME/Settings.php"
fi

chmod +x "$INSTALLDIR/$PRODUCTNAME/InstallScripts/after_remove.sh"
chmod +x "$INSTALLDIR/$PRODUCTNAME/InstallScripts/after_update.sh"
chmod +x "$INSTALLDIR/$PRODUCTNAME/InstallScripts/before_remove.sh"
chmod +x "$INSTALLDIR/$PRODUCTNAME/InstallScripts/before_update.sh"

#On va faire une boucle à partir de "ancienne version + 1" jusqu'a la derniere version incluse
i=$(($OLDVERSION+1))
if [ $OLDVERSION -eq $NEWVERSION ]
then
	i=$OLDVERSION;
	echo "-- Updating same version but different revision, reexecuting patch of $i"
fi

while [ $i -le $NEWVERSION ]
do
    echo "-- Executing patch $MAJORVERSION.$i"
    find "$INSTALLDIR/$PRODUCTNAME/InstallScripts/$MAJORVERSION.$i" -name '*' -exec dos2unix {} 2> /dev/null \;
    bash "$INSTALLDIR/$PRODUCTNAME/InstallScripts/$MAJORVERSION.$i/update.sh"
    i=$(($i+1))
done

if [ -f /tmp/resetdb ]
then
  /bin/sh $INSTALLDIR/$PRODUCTNAME/api/scripts/resetdb.sh
  rm -f /tmp/resetdb
fi


echo "$MAJORVERSION.$NEWVERSION" > "$IPCDIR/$PRODUCTNAME.ver"
echo "-- Update finished"


rm -rf "$TMPDIR"
exit